<?php

namespace Modules\St\Entities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Support\Facades\Auth;
use Spatie\Activitylog\Contracts\Activity;
use Spatie\Activitylog\Traits\LogsActivity;
class ApprovalTask extends Model
{
    use HasFactory,LogsActivity;

    protected $fillable = [];
    protected $table = 'st_approval_tasks';
    protected static $logAttributes = [
        'id',
        'approval_rule_id',
        'approval_rule_id',
        'approval_rollback_id',
        'is_approval',
    ];
    protected static $logOnlyDirty = true;
    public function tapActivity(Activity $activity, string $eventName)
    {
        $activity->log_name = "st_approval_tasks";
        $activity->description = $eventName;
        $activity->causer_id = Auth::user()->id;
    }
    /*protected static function newFactory()
    {
        return \Modules\St\Database\factories\ApprovalTaskFactory::new();
    }*/
}
