<?php

namespace Modules\St\Entities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Support\Facades\Auth;
use Spatie\Activitylog\Contracts\Activity;
use Spatie\Activitylog\Traits\LogsActivity;

class EmailGroupData extends Model
{
    protected $table = 'st_email_group_data';
    protected $fillable = [];
    use HasFactory,LogsActivity;
    protected static $logAttributes = [
        'id',
        'email_group_id',
        'email',
        'status',
    ];
    protected static $logOnlyDirty = true;
    public function tapActivity(Activity $activity, string $eventName)
    {
        $activity->log_name = "st_email_group_data";
        $activity->description = $eventName;
        $activity->causer_id = Auth::user()->id;
    }
    
    /*protected static function newFactory()
    {
        return \Modules\St\Database\factories\EmailGroupDataFactory::new();
    }*/
}
