<?php

namespace Modules\St\Http\Controllers;

use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Illuminate\Support\Facades\DB;
use Modules\St\Entities\Product;
use Modules\St\Entities\GroupLevel1;
use Modules\St\Entities\GroupLevel2;
use Modules\St\Entities\GroupLevel3;
use Modules\St\Entities\Uom;
use Modules\St\Entities\ProductType;

class StockController extends Controller
{
    // This function is use to save a new product record
    function SaveRecord(Request $request) {
        try{
         $Product = new Product();


         $Product->product_id = $request->productId;
         $Product->product_name = $request->productName;
         $Product->product_description = $request->productDescription;
         $Product->uom_id = $request->uomSelect;
         $Product->sku = $request->sku;
         $Product->group_id_level_1 = $request->selectGrpLevel1;
         $Product->group_id_level_2 = $request->selectGrpLevel2;
         $Product->group_id_level_3 = $request->selectGrpLevel3;
         $Product->reorder_level = $request->reorderLevel;
         $Product->reorder_quantity = $request->reordQuantity;
         $Product->product_type_id = $request->productType;
         $Product->gl_analysis_id = $request->glAnalysisName;


         $Product->sms_alert = $this->isChecked($request->sms_alert);
         $Product->email_alert = $this->isChecked($request->email_alert);
         $Product->notification = $this->isChecked($request->notification);
         $Product->status = $this->isChecked($request->status);


         $Product->image_path = "test5";
         $Product->notes = $request->notes;

         $res = $Product->save();
        }catch(\Exception $exception){
         return $exception;
        }

         return "save";

     }

     // This function can be use to check the checkbox values and return boolean type value
     public function isChecked($value){

         if($value == 'on'){
            return true;
         }else{
             return false;
         }
     }

     // This function is use to load all the data in group level 1 when product page is refreshing
     function GetLevel1toProduct(){
         try{
             $dataLevel1ToProduct = DB::table('st_group_level_1')->where('status', '=', 1)->get();

            $responseBody = $this->responseBody(true, "GroupLevel1", "Found", $dataLevel1ToProduct);

         } catch(\Exception $exception) {
             
            $responseBody = $this->responseBody(false, "GroupLevel1", "Error", $exception);
         }
         return response()->json($responseBody);
     }

     // This function is use to load group level 2 data when some group level 1 option selected
     function getLevel1ToLevel2combo($id){
         try{ $getlevel1tolevel2combo = DB::table('st_group_level_2')->select('group_level_2_id','group_level_2')
             ->where('grp_lvl_1_for_id', '=', $id)
             //->orWhere('group_level_2_id', '=', 1)
             ->get();
              $responseBody = $this->responseBody(true, "GroupLevel2", "Found", $getlevel1tolevel2combo);
         }catch(\Exception $exception) {
             $responseBody = $this->responseBody(false, "GroupLevel2", "Error", $exception);
         }
         return response()->json($responseBody);
     }

     // This function is use to load group level 3 data when some group level 2 option selected
     function getLevel2ToLevel3Combo($id){
         try{ $getlevel2tolevel3combo = DB::table('st_group_level_3')->select('group_level_3_id','group_level_3')->where('grp_lvl_2_for_id', '=', $id)->get();
             $responseBody = $this->responseBody(true, "GroupeLevel3", "Found", $getlevel2tolevel3combo);
         } catch(\Exception $exception) {
             $responseBody = $this->responseBody(false, "GroupLevel3", "Error", $exception);
         }
         return response()->json($responseBody);
     }

     // This function is use to get all the product type data when product page is refreshing
     function GetProductType(){
         try{ $ProductType = DB::table('st_product_types')->where('status', '=', 1)->get();
             $responseBody = $this->responseBody(true, "ProductType", "Found", $ProductType);
         } catch(\Exception $exception) {
             $responseBody = $this->responseBody(false, "productType", "Error", $ProductType);
         }
         return response()->json($responseBody);
     }

     // This function is use to get all the Unit of measurement data when product page is refreshing
     function ReadUomData() {
         try{ $res = DB::table('st_uom')->where('status', '=', 1)->get();
             $responseBody = $this->responseBody(true, "UOM", "Found", $res);
         }catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "UOM", "Error", $exception);
         }
         return response()->json($responseBody);
     }

     // This function is use to get all the GL Analysis Account data when product page is refreshing
     function LoadGlId() {
         try{ $res = DB::select('select * from st_gl_analysis');
             $responseBody = $this->responseBody(true, "GLAnalysisId", "Found", $res);
         }catch(\Exception $exception) {
             $responseBody = $this->responseBody(false, "GLAnalysisId", "Error", $exception);
         }
         return response()->json($responseBody);
     }

     // This function is use to get all the products to product list page
     function GetProducts() {
         try{ $res = Product::all();
             $responseBody = $this->responseBody(true, "Products", "Found", $res);
         } catch(\Exception $exception) {
             $responseBody = $this->responseBody(false, "Products", "Error", $exception);
         }
         return response()->json([ "data" => $responseBody ]);
     }

     // This function is use to get all details of a product to product page when edit button clicked
     function Products($id) {
          try{$products =  Product::find($id);

          $product_primary_id = $products->product_primary_id;
          $product_id = $products->product_id;
          $product_name = $products->product_name;
          $product_description = $products->product_description;
          $sku = $products->sku;
          $reorder_level = $products->reorder_level;
          $reorder_quantity = $products->reorder_quantity;
          $sms_alert = $products->sms_alert;
          $email_alert = $products->email_alert;
          $notification = $products->notification;
          $status = $products->status;
          $notes = $products->notes;

          $uom = $products->uom_id;
          $uom_name = Uom::find($uom);

          $level1 = $products->group_id_level_1;
          $group_id_level_1 = GroupLevel1::find($level1);

          $level2 = $products->group_id_level_2;
          $group_id_level_2 = GroupLevel2::find($level2);

          $level3 = $products->group_id_level_3;
          $group_id_level_3 = GroupLevel3::find($level3);

          $proType = $products->product_type_id;
          $product_type_id = ProductType::find($proType);

          $gl_analysis = $products->gl_analysis_id;

          $settings = [
              "product_primary_id" => $product_primary_id,
              "product_id" => $product_id,
              "product_name" => $product_name,
              "product_description" => $product_description,
              "sku" => $sku,
              "reorder_level" => $reorder_level,
              "reorder_quantity" => $reorder_quantity,
              "gl_analysis_id" => $gl_analysis,
              "sms_alert" => $sms_alert,
              "email_alert" => $email_alert,
              "notification" => $notification,
              "status" => $status,
              "notes" => $notes,
              "uom" => $uom_name->uom,
              "grp_level_1" => $level1,
              "grp_level_2" => $level2,
              "grp_level_3" => $level3,
              "product_type" => $product_type_id->product_type,
          ];

          $responseBody = $this->responseBody(true, "Product", "all", ["settings" => $settings]);
         } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "error", "error", $exception);
         }
         return response()->json(["data" => $responseBody]);
      }

     //  This function is use to update a product
      function UpdateProduct(Request $request) {
           try{
            $id =  $request->get('hideProductId');

            $product = Product::find($id);

            $product->product_id = $request->get('productId');
            $product->product_name = $request->get('productName');
            $product->product_description = $request->get('productDescription');
            $product->uom_id = $request->get('uomSelect');
            $product->sku = $request->get('sku');
            $product->group_id_level_1 = $request->get('selectGrpLevel1');
            $product->group_id_level_2 = $request->get('selectGrpLevel2');
            $product->group_id_level_3 = $request->get('selectGrpLevel3');
            $product->reorder_level = $request->get('reorderLevel');
            $product->reorder_quantity = $request->get('reordQuantity');
            $product->product_type_id = $request->get('productType');
            $product->gl_analysis_id = $request->get('glAnalysisName');
            $product->notes = $request->get('notes');

            $product->sms_alert = $this->isChecked($request->sms_alert);
            $product->email_alert = $this->isChecked($request->email_alert);
            $product->notification = $this->isChecked($request->notification);
            $product->status = $this->isChecked($request->status);

            $product->image_path = "testingUpdate";

            $saveProduct = $product->save();

            if($saveProduct) {
                $responseBody = $this->responseBody(true, "Product", "Updated", "");
            }
         } catch (\Exception $exception){
             $responseBody = $this->responseBody(false, "Product", "Error", $exception);
         }
         return response()->json(["data" => $responseBody]);
      }

     // Delete Product
     function DeleteProduct($id) {
        try{  $product = Product::find($id);
              $delete = $product->delete();
              if($delete) {
                  $responseBody = $this->responseBody(true, "Product", "Deleted", null);
              }
        } catch(\Exception $exception) {
                  $responseBody = $this->responseBody(false, "Product", "Error", $exception);
        }
        return response()->json(["data" => $responseBody]);
     }

     //  This function is use to return the response to js file
      function responseBody($success, $name, $message, $result) {
         $body = [
             "success" => $success,
             "name" => $name,
             "message" => $message,
             "result" => $result
         ];
         return $body;
       }
}
